Imports C1.Win.C1FlexGrid

Public Class Form1

    Dim buttonList As New ArrayList()


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'NwindDataSet.Employees' table. You can move, or remove it, as needed.
        'Dim dv As New System.Data.DataView(Me.NwindDataSet.Employees)



        'dv.Sort = "HireDate ASC,BirthDate desc"


        'Me.NwindDataSet.Employees.DefaultView.Sort = "HireDate ASC, BirthDate desc"
        Me.EmployeesTableAdapter.Fill(Me.NwindDataSet.Employees)
        '  Me.C1FlexGrid1.DataSource = dv
        For Each r As Row In C1FlexGrid1.Rows
            If r.Index > 0 Then
                'Set row number
                r(0) = r.Index
                'Create Button
                Dim bt As New Button
                bt.BackColor = SystemColors.Control
                bt.Text = "Find"
                bt.Tag = r.Index 'Tag it so the button knows which row it's on
                AddHandler bt.Click, AddressOf Button_Click
                buttonList.Add(New HostedControl(C1FlexGrid1, bt, r.Index, 3))
            End If
        Next
        Me.C1FlexGrid1.SetUserData(1, 1, "Hydrogen is a highly flammable gas.")
        C1FlexGrid1.Rows.DefaultSize = 21
        C1FlexGrid1.WriteXml("TestZML.xml")
    End Sub

   

    Private Sub C1FlexGrid1_OwnerDrawCell(sender As Object, e As C1.Win.C1FlexGrid.OwnerDrawCellEventArgs) Handles C1FlexGrid1.OwnerDrawCell
        Dim sStyleName As String

        sStyleName = "RowStyle"

        Dim cs As C1.Win.C1FlexGrid.CellStyle = C1FlexGrid1.Styles.Add(sStyleName)

        '-- Set Italics On or Off
        'cs.Font = New Font("Tahoma", 12, FontStyle.Italic)

        cs.Font = New Font(ChrW(23655) & ChrW(23765), 12, FontStyle.Regular, GraphicsUnit.Point, 134)


        Dim rg As C1.Win.C1FlexGrid.CellRange = C1FlexGrid1.GetCellRange(1, 1, 8, C1FlexGrid1.Cols.Count - 1)

        rg.Style = C1FlexGrid1.Styles(sStyleName)
        e.Handled = True
    End Sub

    Private Sub C1FlexGrid1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles C1FlexGrid1.Paint
        For Each hosted As HostedControl In buttonList
            hosted.UpdatePosition()
        Next
    End Sub

    Private Sub Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim bt As Button = CType(sender, Button)
        MsgBox("Clicked on row: " & bt.Tag)
        
    End Sub

    'HostedControl class from sample 'HostedControls' used to embed arbitrary controls into a FlexGrid
    Friend Class HostedControl
        Friend _flex As C1FlexGrid
        Friend _ctl As Control
        Friend _row As Row
        Friend _col As Column

        Friend Sub New(ByVal flex As C1FlexGrid, ByVal hosted As Control, ByVal row As Integer, ByVal col As Integer)
            ' save info 
            _flex = flex
            _ctl = hosted
            _row = flex.Rows(row)
            _col = flex.Cols(col)

            ' insert hosted control into grid 
            _flex.Controls.Add(_ctl)
        End Sub
        Friend Function UpdatePosition() As Boolean
            ' get row/col indices 
            Dim r As Integer = _row.Index
            Dim c As Integer = _col.Index
            If r < 0 OrElse c < 0 Then
                Return False
            End If

            ' get cell rect 
            Dim rc As Rectangle = _flex.GetCellRect(r, c, False)

            ' hide control if out of range 
            If rc.Width <= 0 OrElse rc.Height <= 0 OrElse Not rc.IntersectsWith(_flex.ClientRectangle) Then
                _ctl.Visible = False
                Return True
            End If

            ' move the control and show it 
            _ctl.Bounds = rc
            _ctl.Visible = True

            ' done 
            Return True
        End Function
    End Class

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        ' Create an open file dialog.
        Dim dlg As New System.Windows.Forms.OpenFileDialog
        dlg.DefaultExt = "xml"
        dlg.Filter = "XML File (*.xml)|*.xml"
        ' Initialize the dialog.
        If dlg.ShowDialog <> Windows.Forms.DialogResult.OK Then
            Return
        End If
        ' Load the Xml file (created with WriteXml method).
        C1FlexGrid1.ReadXml(dlg.FileName)
      

      
    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click

        Button2.Font = New Font(Me.Font.Name, 12, FontStyle.Regular, GraphicsUnit.Point, 134)
        '  Button2.Text = ChrW(23655) & ChrW(23765)

        'Trying the Same in C1Flexgrid seems to have no effect:
        'C1FlexGrid1.Cols("LastName").Style.Font = New Font(Me.Font.Name, 12, FontStyle.Regular, GraphicsUnit.Point, 134)
        ' C1FlexGrid1.Cols("LastName").Caption = ChrW(23655) & ChrW(23765)
        C1FlexGrid1.Cols("LastName").StyleNew.Font = New Font(Me.Font.Name, 12, FontStyle.Regular, GraphicsUnit.Point, 134)

        C1FlexGrid1.Cols("LastName").StyleNew.ForeColor = Color.Aquamarine
        'C1FlexGrid1.Styles("Fixed").Font = New Font(Me.Font.Name, 12, FontStyle.Regular, GraphicsUnit.Point, 134)
    End Sub

    Private Sub C1FlexGrid1_StartEdit(sender As Object, e As C1.Win.C1FlexGrid.RowColEventArgs) Handles C1FlexGrid1.StartEdit
        C1FlexGrid1.Editor = TextBox1
    End Sub
End Class
